#include <stdio.h>

int querSumme(long zahl) {
    int summe = 0;
    
    while(zahl > 0) {
        summe += zahl % 10;
        zahl /= 10;
    }
    return summe;
}
    
int querSumme2(int summe, long startZahl, long teiler, int aufruf) {
    long merkZahl = startZahl;
    long zaehler = teiler;
    
    if(startZahl == 1) 
        if(aufruf == 1)
            return(-1);
        else
            return summe;
    

    while(merkZahl % zaehler != 0) {
        zaehler++;
     if(zaehler > 2*sqrtl(merkZahl)) {
            zaehler = merkZahl;
            break;
            }
        
            
    }
    
    summe += querSumme(zaehler);
    
    return querSumme2(summe,merkZahl / zaehler,zaehler, aufruf + 1);
}
        
int testSmith(long zahl) {
    int qSumme = querSumme(zahl);

    int qSumme2 = querSumme2(0,zahl,2,0);

    return(qSumme == qSumme2);
}


void main(void) {
    
    long zahl;
    FILE *eingabeDatei;
    
    if((eingabeDatei = (FILE *) fopen("smith.in","rb")) == NULL) {
        fprintf(stderr,"Kann Eingabedatei nicht ffnen :-(\r\n");
        exit(-1);
    }
    
    while(1) {
        fscanf(eingabeDatei,"%ld",&zahl);
        
        if(zahl == 0)
            break;
        
        do
            zahl++;
        while(!testSmith(zahl));
        
        fprintf(stdout,"%ld\r\n",zahl);
        
    }
   fclose(eingabeDatei);
}
